function [F,FFFram, Vram, errram, X, Y ]=vectorautoregression(data,nlags,dlags, dummy, dumb);

%October 2005

[t,r]=size(data);
nvar=r;

for j=1:nvar
    Y(:,j)=data([nlags+1]:end,j);
    for i=1:nlags
    X(:,j+nvar*(i-1))=data(nlags+1-i:t-i,j);
    end
end


if dumb==1
    for j=1:dlags
        dum(:,j)=dummy([dlags+1-j:end-j],1);
    end;

   dum= [dummy(dlags+1:end) dum];


    xx=[dum X(dlags-nlags+1:end,:)];

else
    xx=X;
end

[len,rr] = size(xx);
time = zeros(len,1);
timesqr = ones(len,1);


for kk = 2:len
    time(kk,:) = time(kk-1,:) +1;
    timesqr(kk,:) = time(kk,:)^2;
    timecu(kk,:) = time(kk,:)^3;
    timequ(kk,:) = time(kk,:)^4;
    
end

constant= ones(len,1);

xx= [constant time xx];

X=xx;

if dumb==1
    Y= Y(dlags-nlags+1:end,:);
else
    Y=Y;
end

Fnew=inv(xx'*xx)*xx'*Y;
F=stack(Fnew,0);

[rr,cc] = size(xx);

errram = Y- xx*Fnew;

vvram=errram'*errram;
Vram=vvram/len;


if dumb==1
    Ftilram =Fnew(dlags+2+3:end,:);
else
    Ftilram= Fnew(3:end,:);
end

for i=1:nlags
    FFram(:,:,i)=Ftilram((i-1)*nvar+1:i*nvar, :);
    FFram(:,:,i)=FFram(:,:,i)';
end


FFFram=FFram(:,:,1);
for kk= 2:nlags
    FFFram= [FFFram, FFram(:,:,kk)];
end

