clear all
close all

load recession_highdebt.mat

recsumstatea=cumsum(recstateay,2);
recsumstateb=cumsum(recstateby,2);

load baseline.mat

sumstatea=cumsum(stateay,2);
sumstateb=cumsum(stateby,2);

rr=3;
cc=round(dsize/rr)+1;

close all

zz=zeros(1,hor);
figure1 = figure;
for j=1:dsize
subplot(dsize,3,3*j-2)
plot(1:1:hor, zz, 'k-')
hold on
grpyat=[(1:1:hor)', recconfidenceya(1,:,j)'; (hor:-1:1)' recconfidenceya(2,hor:-1:1,j)'];
patch(grpyat(:,1), grpyat(:,2), [0.7 0.7 0.7],'edgecolor', [0.7 0.7 0.7]);
plot(1:1:hor, recstateay(j,:), 'b--','LineWidth', 1.5)
hold on
plot(1:1:hor, recstateby(j,:), 'r-.', 'LineWidth', 1.5)
hold on
plot(1:1:hor, recconfidenceyb(1,:,j), 'r', 1:1:hor, recconfidenceyb(2,:,j), 'r', 'LineWidth', 1);
hold on
plot(1:1:hor, zz, 'k-')
axis tight
ylabel(names(j,:))

subplot(dsize,3,(3*j-2)+1)
plot(1:1:hor, sumstatea(j,:), 'b--', 1:1:hor, recsumstatea(j,:),'k-.', 'LineWidth', 1.5)
axis tight

subplot(dsize,3,(3*j-2)+2)
plot(1:1:hor, sumstatea(j,:)./-sumstatea(1,:), 'b--', 1:1:hor, recsumstatea(j,:)./-recsumstatea(1,:),'k-.', 'LineWidth', 1.5)
axis tight

end
% % Create textbox
% annotation(figure1,'textbox',...
%     [0.487012987012988 0.917161434977579 0.099025974025974 0.031390134529148],...
%     'String',{'Linear'},...
%     'LineStyle','none');
% 
% % Create textbox
% annotation(figure1,'textbox',...
%     [0.707792207792209 0.919403587443946 0.199675324675325 0.031390134529148],...
%     'String',{'State Dependent'},...
%     'LineStyle','none');