clear all
close all
clc

load onehp_timing.mat

onehpt_confidenceya=confidenceya;
onehpt_confidenceyb=confidenceyb;
onehpt_stateay=stateay;
onehpt_stateby=stateby;

load bandpass_timing.mat

bpt_confidenceya=confidenceya;
bpt_confidenceyb=confidenceyb;
bpt_stateay=stateay;
bpt_stateby=stateby;

load onehp_romer.mat

onehpr_confidenceya=confidenceya;
onehpr_confidenceyb=confidenceyb;
onehpr_stateay=stateay;
onehpr_stateby=stateby;

load bandpass_romer.mat

bpr_confidenceya=confidenceya;
bpr_confidenceyb=confidenceyb;
bpr_stateay=stateay;
bpr_stateby=stateby;


figure(9)
for j=1:dsize
subplot(dsize,4,4*j-3)
plot(1:1:hor, zz, 'k-')
hold on
grpyat=[(1:1:hor)', onehpt_confidenceya(1,:,j)'; (hor:-1:1)' onehpt_confidenceya(2,hor:-1:1,j)'];
patch(grpyat(:,1), grpyat(:,2), [0.7 0.7 0.7],'edgecolor', [0.7 0.7 0.7]);
plot(1:1:hor, onehpt_stateay(j,:), 'b--','LineWidth', 1.5)
hold on
plot(1:1:hor, onehpt_stateby(j,:), 'r-.', 'LineWidth', 1.5)
hold on
plot(1:1:hor, onehpt_confidenceyb(1,:,j), 'r', 1:1:hor, onehpt_confidenceyb(2,:,j), 'r', 'LineWidth', 1);
hold on
plot(1:1:hor, zz, 'k-')
axis tight
ylabel(names(j,:))

subplot(dsize,4,(4*j-3)+1)
plot(1:1:hor, zz, 'k-')
hold on
grpyat=[(1:1:hor)', onehpr_confidenceya(1,:,j)'; (hor:-1:1)' onehpr_confidenceya(2,hor:-1:1,j)'];
patch(grpyat(:,1), grpyat(:,2), [0.7 0.7 0.7],'edgecolor', [0.7 0.7 0.7]);
plot(1:1:hor, onehpr_stateay(j,:), 'b--','LineWidth', 1.5)
hold on
plot(1:1:hor, onehpr_stateby(j,:), 'r-.', 'LineWidth', 1.5)
hold on
plot(1:1:hor, onehpr_confidenceyb(1,:,j), 'r', 1:1:hor, onehpr_confidenceyb(2,:,j), 'r', 'LineWidth', 1);
hold on
plot(1:1:hor, zz, 'k-')
axis tight


subplot(dsize,4,(4*j-3)+2)
plot(1:1:hor, zz, 'k-')
hold on
grpyat=[(1:1:hor)', bpt_confidenceya(1,:,j)'; (hor:-1:1)' bpt_confidenceya(2,hor:-1:1,j)'];
patch(grpyat(:,1), grpyat(:,2), [0.7 0.7 0.7],'edgecolor', [0.7 0.7 0.7]);
plot(1:1:hor, bpt_stateay(j,:), 'b--','LineWidth', 1.5)
hold on
plot(1:1:hor, bpt_stateby(j,:), 'r-.', 'LineWidth', 1.5)
hold on
plot(1:1:hor, bpt_confidenceyb(1,:,j), 'r', 1:1:hor, bpt_confidenceyb(2,:,j), 'r', 'LineWidth', 1);
hold on
plot(1:1:hor, zz, 'k-')
axis tight


subplot(dsize,4,(4*j-3)+3)
plot(1:1:hor, zz, 'k-')
hold on
grpyat=[(1:1:hor)', bpr_confidenceya(1,:,j)'; (hor:-1:1)' bpr_confidenceya(2,hor:-1:1,j)'];
patch(grpyat(:,1), grpyat(:,2), [0.7 0.7 0.7],'edgecolor', [0.7 0.7 0.7]);
plot(1:1:hor, bpr_stateay(j,:), 'b--','LineWidth', 1.5)
hold on
plot(1:1:hor, bpr_stateby(j,:), 'r-.', 'LineWidth', 1.5)
hold on
plot(1:1:hor, bpr_confidenceyb(1,:,j), 'r', 1:1:hor, bpr_confidenceyb(2,:,j), 'r', 'LineWidth', 1);
hold on
plot(1:1:hor, zz, 'k-')
axis tight
% %ylabel('State-dependent')
% %xlabel('quarter')
% title(names(j,:))

end


% % subplot(dsize-3,3,(3*(j-3)-2)+2)
% plot(1:1:hor, zz, 'k-')
% hold on
% grpyat=[(1:1:hor)', confidenceya(1,:,j)'; (hor:-1:1)' confidenceya(2,hor:-1:1,j)'];
% patch(grpyat(:,1), grpyat(:,2), [0.7 0.7 0.7],'edgecolor', [0.7 0.7 0.7]);
% plot(1:1:hor, stateay(j,:), 'b--','LineWidth', 1.5)
% hold on
% plot(1:1:hor, stateby(j,:), 'r-.', 'LineWidth', 1.5)
% hold on
% plot(1:1:hor, confidenceyb(1,:,j), 'r', 1:1:hor, confidenceyb(2,:,j), 'r', 'LineWidth', 1);
% hold on
% plot(1:1:hor, zz, 'k-')
% axis tight
% % %ylabel('State-dependent')
% % %xlabel('quarter')
% % title(names(j,:))
% end