function [J]=stack(matrix,m)

%INPUTS:  matrix - the matrix whose columns we want to stack in one vector
%         m      - indicates the  number of columns that we do not want to
%                  include
% OUTPUT:  J - column vector of stacked columns of input matrix

[t,r]=size(matrix);

J=matrix(:,1);
for i=2:(r-m);
    J=cat(1,J,matrix(:,i));
end;